function [p,N]=proba(T,A,L)
%proba(T,A,L)
%T : nombre positif
%A : vecteur
%L : matrice
%Etant donnes  une temperature T, un chemin A et une matrice de distance
%entre les villes L, on sort son poids de Boltzmann p ainsi que la longeur N du
%chemin A.
n=length(A);
K=zeros(1,n-1);
    for h=1:n-1
        K(1,h)=L(A(h),A(h+1));
    end
N=sum(K(1,:))+L(A(n),A(1));
p=exp(-N/T);