function trajet;
%ecrire trajet dans une fenetre matlab pour lancer l'application

%Initialisation
cpt=1;      %Compte le nombre de villes dessines
button=1;   %Dtecte le bouton de souris utilis

%On supprime toute figure existante
close all
    
    
%Definition de la carte de fond   
X=imread('carte_france.jpg','jpg');
Y1=flipud(X(:,:,1));
Y2=flipud(X(:,:,2));
Y3=flipud(X(:,:,3));
Y(:,:,1)=Y1;
Y(:,:,2)=Y2;
Y(:,:,3)=Y3;
    
%Construction de la fenetre graphique
figure( ...
      'Name','Le voyageur de commerce', ...
      'NumberTitle','off', ...
      'Color', [0.8 0.8 0.9]);
%Definition des axes : non visibles
axes( ...
      'Units','normalized', ...
      'Visible','off', ...
      'Position',[0.15 0.13 0.75 0.90], ...
      'NextPlot','add');
%Affichage de la figure
imagesc(Y);
%Affichage des instructions
text(430,655,'Choix des villes : clic gauche - Calcul du trajet : clic droit', ...
      'HorizontalAlignment','center');
  
   
% Le bouton recommencer : relance l'application
btnPos=[0.5 0 0.5 0.1];
labelColor=[0.8 0.8 0.8];
callbackStr='trajet;';
uicontrol( ...
      'Style','pushbutton', ...
      'Units','normalized', ...
      'Position',btnPos, ...
      'String','Recommencer', ...
      'Interruptible','on', ...
      'Callback',callbackStr);

%Enregistrement des villes
while button==1
    [P(cpt,1),P(cpt,2),button]=ginput(1);   %Enregistre les coord. des villes
    if button==1
        plot(P(cpt,1),P(cpt,2),'ko');           %Trace la ville
    end
    cpt=cpt+1;
end

%Donnes du systme
n=cpt-2;          %Nbre de villes
T=10000;         %Temprature
N=10000;        %Nbre d'itrations


%Chemins  suivre : on stocke tous les chemins de l'algorithme dans les
%lignes de la matrice C. Le chemin initial : les ville par ordre
%chronologique d'entree
C=zeros(N,n);   
C(1,:)=1:n;
%Definition du chemin voisin
C1=zeros(1,n);
C2=zeros(1,n);

%Distance entre les villes i et j : stockee dans la matrice L
L=zeros(n,n);
for h=1:n
    for l=1:n
        L(h,l)=sqrt((P(h,1)-P(l,1))^2+(P(h,2)-P(l,2))^2);
    end
end

%Algorithme
for k=1:N
    %Tirage au sort des villes  changer et classement chronologique
    i1=floor((n-1)*rand(1))+1;
    i2=floor((n-2)*rand(1))+1;
    if i2>=i1 i2=i2+1;
    end
    i=norm([i1 i2],-inf);
    j=norm([i1 i2],inf);
    
    %Dfinition du chemin voisin : de 1 en i-1 de j  i+1 de j+1  n
    C2=fliplr(C(k,:));
    C1(1,1:i-1)=C(k,1:i-1);
    C1(1,i:j)=C2(1,n-j+1:n-i+1);
    C1(1,j+1:n)=C(k,j+1:n);
    
    %Comparaison des nergies
    [p1,M1]=proba(k*T,C1(1,:),L);
    [p,M(1,k)]=proba(k*T,C(k,:),L);
    
    %Choix du chemin modifi
    if p1>p
        C(k+1,:)=C1(1,:);
    elseif bernoulli(p1/p)==1
        C(k+1,:)=C1(1,:);
    else C(k+1,:)=C(k,:);
    end
end

%Trac du dernier chemin obtenu par l'algorithme
for h=1:n-1
    plot([P(C(N,h),1),P(C(N,h+1),1)],[P(C(N,h),2),P(C(N,h+1),2)],'r');
end
plot([P(C(N,n),1),P(C(N,1),1)],[P(C(N,n),2),P(C(N,1),2)],'r');
hold off
